/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * cmemoѤΤޤޤʴؿ
 */

/*
 * Cmemo : Text Editor
 * misc.c - source file for various function of cmemo
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>
#include <signal.h>
#include <sys/stat.h>
#include "cme_def.h"
#include "cmemo.h"
#include "ini_file.h"
#include "cme_misc.h"
#include "keys.h"

#define ALM_RCV_DONE 0
#define ALM_RCV_WAIT 1

static int search_visi_flag = 0; /* 0:ɽ 1:ɽ */
static int alarm_rcv_flag = ALM_RCV_DONE; /* 顼Ԥե饰 */
static GtkWidget *message_entry = NULL;
static char szTrace[4096];

/* Хåؿϡ0(FALSE)֤Ȥˤäƥ٥Ȥ */
/* ã³ԤǥեȤư򤵤Ǥ롣٥ */
/* Ȥߤ᤿ϡ1(TRUE)֤                      */

/*******************
   mlwrite
 *******************/
void init_mlwrite(GtkWidget *msg_entry)
{
  if (msg_entry != NULL) {
    message_entry = msg_entry;
  }
  return;
}

/*******************
   mlwrite̵
 *******************/
void deinit_mlwrite(void)
{
  message_entry = NULL;
  return;
}

/**************************************
   å饤˥åɽ
 **************************************/
#if 0
void mlwrite(char *text, int flag)
{
  static gint line_dsp_flag = 1;


  /* ޥɤȯԤƤֹɽι򤷤ʤ */
  if ((line_dsp_flag == 0) && (flag == DELAY_UPDATING)) {
    line_dsp_flag = 1;
    return;
  }

  if (flag != DELAY_UPDATING) {
    line_dsp_flag = 0;
  }

  if (message_entry == NULL) {
    printf("message_entry is null\n");
  }
  else {
    gtk_entry_set_text(GTK_ENTRY(message_entry), text);
  }

  return;
}
#endif
void mlwrite(int std_out_flg, int flag, char *pszFormat, ...)
{
  static gint line_dsp_flag = 1;

  /* ޥɤȯԤƤֹɽι򤷤ʤ */
  if ((line_dsp_flag == 0) && (flag == ML_DELAYED)) {
    line_dsp_flag = 1;
    return;
  }

  if (flag != ML_DELAYED) {
    line_dsp_flag = 0;
  }

  /* ѰʬեޥåȤ˽äʸѴƼ */
  if(pszFormat != NULL) {
  	va_list ptr;
  	va_start(ptr, pszFormat);
  	vsprintf(szTrace, pszFormat, ptr);
  	va_end(ptr);
  }
  else {
  	strcpy(&szTrace[0], "(null)");
  }

  switch (std_out_flg) {
  case ML_S_ONLY:
    if (cm_console_out != 0) {
      printf("%s\n", szTrace);
    }
    break;
  case ML_E_ONLY:
    if (message_entry != NULL) {
      gtk_entry_set_text(GTK_ENTRY(message_entry), szTrace);
    }
    break;
  case ML_BOTH:
    if (message_entry != NULL) {
      gtk_entry_set_text(GTK_ENTRY(message_entry), szTrace);
    }
    if (cm_console_out != 0) {
      printf("%s\n", szTrace);
    }
    break;
  default:
    printf("\?\?\?%s\n", szTrace);
    break;
  }
  return;
}

/*******************************
   (ޤ̤б 2000/10/02)
 *******************************/
void print_cb(GtkWidget *widget, gpointer data)
{
  mlwrite(ML_E_ONLY, ML_IMMEDIATELY, "SORRY! \"PRINT\" IS NOT SUPPORTED!");
  return;
}

/**********
   ԡ
 **********/
int edit_copy(GtkWidget *widget, gpointer data)
{
  GtkWidget *copy_widget;

  if (data == NULL) {
    /* NULLξϥ졼ǸƤӽФ줿ץ */
    /* ˥塼 Copy ¹Ԥ줿Ȥˤʤ롣ΤȤϤλ */
    /* ǥΤ륦åȤФư褦ˤ롣 */
    copy_widget = cm_focused_editable;
  }
  else {
    copy_widget = data;
  }

  if (GTK_IS_TEXT_VIEW(copy_widget)) {
    GtkTextBuffer *buffer;
    buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(copy_widget));
    gtk_text_buffer_copy_clipboard(buffer,
                                   gtk_clipboard_get(GDK_SELECTION_CLIPBOARD));
  }
  else {
    gtk_editable_copy_clipboard(GTK_EDITABLE(copy_widget));
  }

  return(0);
}

/************
   ڤ
 ************/
int edit_cut(GtkWidget *widget, gpointer data)
{
  GtkWidget *cut_widget;

  if (data == NULL) {
    /* NULLξϥ졼ǸƤӽФ줿ץ */
    /* ˥塼 Cut ¹Ԥ줿Ȥˤʤ롣ΤȤϤλ  */
    /* ǥΤ륦åȤФư褦ˤ롣 */
    cut_widget = cm_focused_editable;
  }
  else {
    cut_widget = data;
  }

  if (GTK_IS_TEXT_VIEW(cut_widget)) {
    GtkTextBuffer *buffer;
    buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(cut_widget));
    gtk_text_buffer_cut_clipboard(buffer,
                                  gtk_clipboard_get(GDK_SELECTION_CLIPBOARD),
                                  GTK_TEXT_VIEW(cut_widget)->editable);
  }
  else {
    gtk_editable_cut_clipboard(GTK_EDITABLE(cut_widget));
  }

  return(0);
}

/************
   Žդ
 ************/
int edit_paste(GtkWidget *widget, gpointer data)
{
  GtkWidget *paste_widget;

  if (data == NULL) {
    /* NULLξϥ졼ǸƤӽФ줿ץ  */
    /* ˥塼 Paste ¹Ԥ줿Ȥˤʤ롣ΤȤϤλ */
    /* ǥΤ륦åȤФư褦ˤ롣  */
    paste_widget = cm_focused_editable;
  }
  else {
    paste_widget = data;
  }

  if (GTK_IS_TEXT_VIEW(paste_widget)) {
    GtkTextBuffer *buffer;
    buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(paste_widget));
    gtk_text_buffer_paste_clipboard(buffer,
                                    gtk_clipboard_get(GDK_SELECTION_CLIPBOARD),
                                    NULL,
                                    GTK_TEXT_VIEW(paste_widget)->editable);
  }
  else {
    gtk_editable_paste_clipboard(GTK_EDITABLE(paste_widget));
  }

  return(0);
}

/************
   
 ************/
void select_all_cb(GtkWidget *widget, gpointer data)
{
  GtkTextIter start_iter;
  GtkTextIter end_iter;

  if (GTK_IS_TEXT_VIEW(cm_focused_editable)) {
    GtkTextBuffer *buffer;
    buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(cm_focused_editable));
    gtk_text_buffer_get_start_iter(buffer, &start_iter);
    gtk_text_buffer_get_end_iter(buffer, &end_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "selection_bound", &start_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "insert", &end_iter);
  }
  else {
    gtk_editable_select_region(GTK_EDITABLE(cm_focused_editable), 0, -1);
  }
  return;
}

/*******************
   entry
 *******************/
gint entry_select_all_cb(GtkWidget *widget, gpointer data)
{
  gtk_editable_select_region(GTK_EDITABLE(widget), 0, -1);
  return(FALSE);
}

/**********************************************
   ߥեΤ륦åȤ򵭲
 **********************************************/
gint editable_focus_in_cb(GtkWidget *widget, gpointer data)
{
  cm_focused_editable = widget;
  return(FALSE);
}

/**********************
   Сɽ
 **********************/
void version_cb(GtkWidget *widget, gpointer data)
{
  mlwrite(ML_E_ONLY, ML_IMMEDIATELY, VERSION_INFO);
  return;
}

/**************************************
   ݥåץåץ˥塼ݥåץå
 **************************************/
gboolean popup_menu_cb(GtkWidget *widget, GdkEvent *event)
{
  if (event->type == GDK_BUTTON_PRESS) {
    GdkEventButton *bevent = (GdkEventButton *)event;
    if (bevent->button == 3) {
      gtk_menu_popup(GTK_MENU(widget), NULL, NULL, NULL, NULL,
                     bevent->button, bevent->time);
      return TRUE;
    }
  }
  return FALSE;
}

/*********************************
   ʸΰɽ/ɽ
 *********************************/
void search_visi_cb(GtkWidget *widget, gpointer data)
{
  if (search_visi_flag == 0) {
    gtk_widget_show(cm_search.button_up);
    gtk_widget_show(cm_search.button_dn);
    gtk_widget_show(cm_search.entry);
    gtk_widget_grab_focus(cm_search.entry);
    search_visi_flag = 1;
  }
  else {
    gtk_widget_hide(cm_search.button_up);
    gtk_widget_hide(cm_search.button_dn);
    gtk_widget_hide(cm_search.entry);
    gtk_widget_grab_focus(cm_document.textbox);
    search_visi_flag = 0;
  }
}

/**************************
   ʸΰɽ
 **************************/
void search_open_cb(GtkWidget *widget, gpointer data)
{
  gtk_widget_show(cm_search.button_up);
  gtk_widget_show(cm_search.button_dn);
  gtk_widget_show(cm_search.entry);
  gtk_widget_grab_focus(cm_search.entry);
  search_visi_flag = 1;

  return;
}

/************************
   ưޤ֤ON/OFF
 ************************/
void line_wrap_cb(GtkWidget *widget, gpointer data)
{
  struct text_struct *doc;
  GtkTextView *text_view;

  doc = (struct text_struct *)data;
  text_view = GTK_TEXT_VIEW(doc->textbox);

  /* δؿƤФ줿ǥå֤ȿžϤǤ˽äƤ餷 */
  /*gtk_check_menu_item_toggled(GTK_CHECK_MENU_ITEM(widget));*/

  if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(widget)) == TRUE) {
    gtk_text_view_set_border_window_size(text_view, GTK_TEXT_WINDOW_RIGHT, 8);
    /*gtk_text_view_set_wrap_mode(text_view, GTK_WRAP_WORD);*/
    gtk_text_view_set_wrap_mode(text_view, GTK_WRAP_CHAR);
  }
  else {
    gtk_text_view_set_border_window_size(text_view, GTK_TEXT_WINDOW_RIGHT, 0);
    gtk_text_view_set_wrap_mode(text_view, GTK_WRAP_NONE);
  }
  return;
}

/**********************
   ֹɽON/OFF
 **********************/
void show_line_numbers_cb(GtkWidget *widget, gpointer data)
{
  struct text_struct *doc;
  GtkTextView *text_view;

  doc = (struct text_struct *)data;
  text_view = GTK_TEXT_VIEW(doc->textbox);

  /* δؿƤФ줿ǥå֤ȿžϤǤ˽äƤ餷 */
  /*gtk_check_menu_item_toggled(GTK_CHECK_MENU_ITEM(widget));*/

  if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(widget)) == TRUE) {
    gtk_text_view_set_border_window_size(text_view, GTK_TEXT_WINDOW_LEFT, 24);
  }
  else {
    gtk_text_view_set_border_window_size(text_view, GTK_TEXT_WINDOW_LEFT, 0);
  }
  return;
}

/***************************
   ¹cmemoο֤
 ***************************/
int count_opened_cmemo(void)
{
  FILE *fp;
  char buf[256];
  int cmemo_count;

  cmemo_count = 0;

#if OPENBSD
  if ((fp = popen("ps -a", "r")) != NULL) {
#else
  if ((fp = popen("ps -A", "r")) != NULL) {
#endif
    while (fgets(&buf[0], sizeof(buf), fp) != NULL) {
      if (strstr(&buf[0], "cmemo") != NULL) {
        cmemo_count++;
      }
    }
    pclose(fp);
  }
  else {
    perror("popen");
    return(-1);
  }
  return(cmemo_count);
}

/***********************************
   SIGALRMФ륳Хåؿ
 ***********************************/
void cme_sig_alarm(int sig)
{
  alarm_rcv_flag = ALM_RCV_DONE;
  signal(SIGALRM, cme_sig_alarm);
  return;
}

/******************************************************
   ¹ΥץƤեå
 ******************************************************/
int cme_file_check(char *chr_chk_pid, char *chr_cme_pid,
                   char *filename, char *command)
{
  pid_t own_pid;
  pid_t chk_pid;
  char kill_buf[256];
  char opened_file[512];

  own_pid = getpid();

  sprintf(&kill_buf[0], "-QF%s", chr_cme_pid);
  chk_pid = (pid_t)atoi(chr_chk_pid);
  if (write_shared_mem(&kill_buf[0]) == 0) {
    if (own_pid != chk_pid) {
      alarm_rcv_flag = ALM_RCV_WAIT;
      kill(chk_pid, SIGUSR1);
    }
    else {
      return(0);
    }
    /* debug */
    /*printf("chk_pid : %d\n", chk_pid);*/
    /*printf("filename : %s\n", filename);*/

    /* λǤޤ顼ॷʥμԤǤäϡ */
    /* pause() ˤä OS ֤¹ԥץؤ */
    /* 褦ˤ롣(ͳϿԲ˽񤤤Ƥ)         */
    if (alarm_rcv_flag == ALM_RCV_WAIT) {
      /* 1Ԥ(SIGALRMƤϤ) */
      alarm(1);
      pause();
      alarm_rcv_flag = ALM_RCV_DONE;
    }
    /* ö֤ */
    /*while (gtk_events_pending()) {
      gtk_main_iteration();
    }*/
    /* ʳ᤯ʥãȶͭν񤭴餷 */
    /* Ȥ⥷ʥOSΥåؤΤ...  */

    /* LinuxǤϥʥǼ¹Υץؤ褦 */
    /* SolarisǤŪOS֤¾Υץؤʤ */
    /* ͭν񤭴˰ʲνäƤޤ...   */

    if (read_shared_mem(&opened_file[0]) == 0) {
      /*printf("filename     : %s\n", filename);*/
      /*printf("rev filename : %s\n", &opened_file[0]);*/
      if (strcmp(&opened_file[0], filename) == 0) {
        /* debug */
        /*printf("rev filename : %s\n", &opened_file[0]);*/
        if (write_shared_mem(command) == 0) {
          /*printf("do kill : %s\n", command);*/
          kill(chk_pid, SIGUSR1);
        }
        return(1);
      }
    }
  }

  return(0);
}

/**********************************
   ¹Υץå
 **********************************/
int check_process(char *cme_pid, char *filename, char *command)
{
  FILE *fp;
  char buf[256];
  int cmemo_count;
  char elements[4][64];
  int i;
  int pid_index;
  int file_check_rtn;

  cmemo_count = 0;
  pid_index = -1;

#if OPENBSD
  if ((fp = popen("ps -a", "r")) != NULL) {
#else
  if ((fp = popen("ps -A", "r")) != NULL) {
#endif
    fgets(&buf[0], sizeof(buf), fp);
    sscanf(&buf[0],
           "%s %s %s %s",
           &elements[0][0],
           &elements[1][0],
           &elements[2][0],
           &elements[3][0]);
    for (i = 0; i < 4; i++) {
      if (strcmp(&elements[i][0], "PID") == 0) {
        pid_index = i;
        break;
      }
    }

    /*if (pid_index == -1) {
      pclose(fp);
      return(-1);
    }*/

    /* Ū0Ȥ */
    pid_index = 0;

    while (fgets(&buf[0], sizeof(buf), fp) != NULL) {
      /*printf("%s", &buf[0]);*/
      sscanf(&buf[0],
             "%s %s %s %s",
             &elements[0][0],
             &elements[1][0],
             &elements[2][0],
             &elements[3][0]);
      if (strstr(&buf[0], "cmemo") != NULL) {
        cmemo_count++;
        file_check_rtn = cme_file_check(&elements[pid_index][0],
                                        cme_pid,
                                        filename,
                                        command);
        if (file_check_rtn > 0) {
          pclose(fp);
          return(cmemo_count);
        }
      }
    }
    pclose(fp);
  }
  else {
    perror("popen");
    return(-1);
  }
  return(0);
}

/*******************************
   UTF-8ʸ򥫥Ȥ
 *******************************/
int get_char_count(unsigned char *buf, int loop_cnt)
{
  register unsigned char *buf_end;
  register unsigned char *pos;
  register int char_count;

  char_count = 0;
  buf_end = buf + loop_cnt;
  for (pos = buf; pos < buf_end; pos++) {
    if ((int)*pos > 0x7F) { /* asciiʳ */
      if ((int)*pos > 0xBF) { /* UTF-8Ƭ */
        char_count++;
      }
    }
    else {
      char_count++;
    }
  }
  return(char_count);
}

/**********************************
   Ԥإ뤹٤δؿ
 **********************************/
int scrollbar_update(gpointer cur_doc,
                     unsigned int scroll_line,
                     GtkTextIter *pscroll_iter)
{
  struct text_struct *doc;
  GtkTextBuffer *buffer;
  GtkTextIter scroll_iter;
  /*gboolean result;*/

  if (scroll_line < 0) {
    return(-1);
  }
  /* debug */
  /*printf("scrollbar_update : scroll_line = %d\n", scroll_line);*/
  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  if (pscroll_iter == NULL) {
    /* gtk_text_buffer_get_iter_at_line means displeyed line */
    /*gtk_text_buffer_get_iter_at_line(buffer, &scroll_iter, scroll_line);*/
    gtk_text_buffer_get_iter_at_line_index(buffer, &scroll_iter, scroll_line, 0);
    gtk_text_buffer_place_cursor(buffer, &scroll_iter);
  }
  /*result = gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(doc->textbox),
                                        &scroll_iter,
                                        0.0,
                                        FALSE,
                                        0.0,
                                        0.0);*/
  gtk_text_view_scroll_to_mark(GTK_TEXT_VIEW(doc->textbox),
                               gtk_text_buffer_get_mark(buffer, "insert"),
                               0.0, FALSE, 0.0, 0.0);
  /*if (result == TRUE) {*/
    return(0);
  /*}
  else {
    return(-1);
  }*/
}

/********************************
   EUC_JPʸ򥫥Ȥ
 ********************************/
int get_char_count_euc(unsigned char *buf, int loop_cnt)
{
  register unsigned char *buf_end;
  register unsigned char *pos;
  register int char_count;

  char_count = 0;
  buf_end = buf + loop_cnt;
  for (pos = buf; pos < buf_end; pos++) {
    /* EUC(ХʸǤϤʤ)Ƚ */
    if ((int)*pos > 0x7F) {
      if ((int)*pos != 0x8F) {
        pos++;
      }
      else {
        pos++;
        pos++;
      }
    }
    char_count++;
  }
  return(char_count);
}
