/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * ״Ϣδؿ
 */

/*
 * Cmemo : Text Editor
 * jump.c - source file for various jump
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "linenum.h"
#include "search.h"
#include "cme_misc.h"
#include "jump.h"

static int jump_visi_flag = 0; /* 0:ɽ 1:ɽ */

/****************************************************
   ԥΰɽɽˤꤹ
 ****************************************************/
void jump_visi_cb(GtkWidget *widget, gpointer cur_doc)
{
  if (jump_visi_flag == 0) {
    gtk_widget_show(cm_jump.button);
    gtk_widget_show(cm_jump.entry);
    gtk_widget_grab_focus(cm_jump.entry);
    jump_visi_flag = 1;
  }
  else {
    gtk_widget_hide(cm_jump.button);
    gtk_widget_hide(cm_jump.entry);
    gtk_widget_grab_focus(cm_document.textbox);
    jump_visi_flag = 0;
  }
  return;
}

/***************************************************************
   (δؿֹ1ԤǤ)
 ***************************************************************/
void tag_jump_cb(GtkWidget *widget, gpointer cur_doc)
{
  int line;
  char *buf;
  int jump_line_no;          /* ֹ */
  int jump_line_col_byte;    /* ֹ(Х) */
  int jump_line_col;         /* ֹ(ʸ) */
  char jump_file_name[1024]; /* פե̾ */
  char *jump_file_name_start;
  char *jump_file_name_end;
  char *comma_pos;
  unsigned char *chr_pos;
  struct text_struct *doc;
  char command[2048];
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;

  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  line = 0;
  buf = NULL;
  jump_line_no = 0;
  jump_line_col = 0;

  /* ΤԤ1ʬ */
  gtk_text_buffer_get_iter_at_mark(buffer,
                                   &start_iter,
                                   gtk_text_buffer_get_mark(buffer, "insert"));
  line = gtk_text_iter_get_line(&start_iter);
  gtk_text_iter_set_line_offset(&start_iter, 0);
  memcpy(&end_iter, &start_iter, sizeof(GtkTextIter));
  if (gtk_text_iter_forward_to_line_end(&end_iter) == FALSE) {
    return;
  }
  buf = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);

  /* Ǥֹȷֹ */
  if (buf != NULL) {
    /* debug */
    /*printf("%d:", line);*/
    /*printf("%s\n", buf);*/
    /* ֹ */
    jump_line_no = atoi(buf);
    comma_pos = strchr(buf, ',');
    if (comma_pos != NULL) {
      /* ֹ */
      jump_line_col_byte = atoi(comma_pos + 1);
      if ((chr_pos = strchr(comma_pos, ':')) != NULL) {
        chr_pos++;
        /* ʸ򥫥Ȥ */
        jump_line_col = get_char_count(chr_pos, jump_line_col_byte);
      }
    }
    /* debug */
    /*printf("jline:%d\n", jump_line_no);*/
    /*printf("jcol:%d\n", jump_line_col);*/
    g_free(buf);
  }
  else {
    return;
  }

  /* 0ܤ˥פϤꤨʤ */
  if (jump_line_no == 0) {
    return;
  }

  while (gtk_text_iter_backward_line(&start_iter) == TRUE) {
    gtk_text_iter_set_line_offset(&start_iter, 0);
    memcpy(&end_iter, &start_iter, sizeof(GtkTextIter));
    if (gtk_text_iter_forward_to_line_end(&end_iter) == FALSE) {
      return;
    }
    buf = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);
    if (buf != NULL) {
      /* debug */
      /*printf("%d : ", i);*/
      /*printf("%s\n", buf);*/
      if (strncmp(buf, "-------", strlen("-------")) == 0) {
        if ((jump_file_name_start = strstr(buf, "- ")) != NULL) {
          jump_file_name_start = jump_file_name_start + 2;
          if ((jump_file_name_end = strstr(jump_file_name_start, " -")) != NULL) {
            memset(&jump_file_name[0], 0, sizeof(jump_file_name));
            memcpy(&jump_file_name[0],
                   jump_file_name_start,
                   jump_file_name_end - jump_file_name_start);
            g_free(buf);
            break;
          }
        }
      }
      g_free(buf);
    }
  }

  /* ե̾ǤƤʤ */
  if ((int)jump_file_name[0] == 0) {
    return;
  }
  else {
    /* debug */
    /*printf("jumpfilename:%s\n", &jump_file_name[0]);*/
    sprintf(&command[0],
            "cmemo -G%d,%d %s &",
            jump_line_no,
            jump_line_col,
            &jump_file_name[0]);
    /* debug */
    /*printf("command : %s\n", &command[0]);*/
    system(&command[0]);
  }
  return;
}

/************************
   ԥץܥ󲡲
 ************************/
void line_jump_cb(GtkWidget *widget, gpointer cur_doc)
{
  char *jump_word;


  gtk_widget_grab_focus(cm_document.textbox);

  jump_word = gtk_editable_get_chars(GTK_EDITABLE(cm_jump.entry), 0, -1);
  if ((jump_word == NULL) || ((int)*jump_word == (int)'\0')) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, "Input Number to Jump!!");
    if (jump_word) {
      g_free(jump_word);
    }
    return;
  }

  line_jump(jump_word, cur_doc);

  g_free(jump_word);

  jump_visi_cb(widget, cur_doc);

  /* ԥϥȥ꡼򥯥ꥢ */
  gtk_entry_set_text(GTK_ENTRY(cm_jump.entry), "");

  return;
}

/*******************************************************
   ԥ(δؿˤ1ֹϤ)
 *******************************************************/
void line_jump(char *jump_word, gpointer cur_doc)
{
  gint jump_line_num;
  gchar *comma_pos;
  gint jump_col;
  struct text_struct *doc;
  gint all_lines;
  GtkTextIter jump_iter;
  GtkTextBuffer *buffer;


  doc = &cm_document;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));

  jump_line_num = atoi(jump_word);
  jump_col = 0;
  if ((comma_pos = strchr(jump_word, ',')) != NULL) {
    jump_col = atoi(comma_pos + 1);
  }

  /* debug */
  /*printf("jump_word     : %s\n", jump_word);*/
  /*printf("jump_line_num : %d\n", jump_line_num);*/

  all_lines = gtk_text_buffer_get_line_count(buffer);
  if ((jump_line_num < 1) || (jump_line_num > all_lines)) {
    /* "Can\'t Jump to %s!!" */
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, CME_CANT_JUMP, jump_word);
    return;
  }

  /*  */
  gtk_text_buffer_get_iter_at_line_index(buffer,
                                         &jump_iter,
                                         jump_line_num - 1,
                                         jump_col);
  gtk_text_buffer_place_cursor(buffer, &jump_iter);
  scrollbar_update(doc, jump_line_num - 1, &jump_iter);

  /* ɽ */
  mlwrite(ML_E_ONLY,
          ML_IMMEDIATELY,
          "Jumped : %s",
          jump_word);

  return;
}
