/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * ߥåȤΤԤιֹؿ
 */

/*
 * Cmemo : Text Editor
 * linenum.c - source file for getting current line number
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "files.h"
#include "coloron.h"
#include "linenum.h"
#include "cme_misc.h"
#include "bm_search.h"
#include "keys.h"


unsigned int cm_all_lines; /*ƥȤԿ*/

static int line = 0; /* ߲ܤǤ뤫ɽѿ */
static int column = 0; /* åȰ֤ηֹ */
static int kakko1_count = 0; /* { } οͭ */
static int kakko2_count = 0; /* ( ) οͭ */

/* local declarations */
static void kakko_add_cb(const gchar *buf);
static void kakko_del_cb(const gchar *buf);
/*static int update_text(gpointer cur_doc);*/


/* Хåؿϡ0(FALSE)֤Ȥˤäƥ٥Ȥ */
/* ã³ԤǥեȤư򤵤Ǥ롣٥ */
/* Ȥߤ᤿ϡ1(TRUE)֤                      */

/****************************************
   ߥåȤΤԤιֹ֤
 ****************************************/
int get_cur_line_number(void)
{
  return line;
}

/****************************************
   ߥåȤΤԤιֹ
 ****************************************/
void set_cur_line_number(int line_num)
{
  line = line_num;
  return;
}

/****************************************
   ̤б֤ɽѿ
 ****************************************/
void init_kakko_count(void)
{
  kakko1_count = 0; /* { } οͭ*/
  kakko2_count = 0; /* ( ) οͭ*/
  return;
}

void
line_count_insert(GtkTextBuffer *buffer,
                  GtkTextIter *iter,
                  const gchar *text,
                  gint len,
                  gpointer data)
{
  struct text_struct *doc;

  doc = (struct text_struct *)data;

  kakko_add_cb(text);

  line_number_cb(GTK_TEXT_VIEW(doc->textbox), 0, 0, 0, doc);

  /*Կ򹹿*/
  cm_all_lines = gtk_text_buffer_get_line_count(buffer);
  /* debug */
  /*printf("line_count_insert cm_all_lines : %d\n", cm_all_lines);*/

  return;
}

void
line_count_delete(GtkTextBuffer *buffer,
                  GtkTextIter *start,
                  GtkTextIter *end,
                  gpointer data)
{
  gchar *text;
  struct text_struct *doc;

  doc = (struct text_struct *)data;

  text = gtk_text_buffer_get_text(buffer, start, end, TRUE);
  kakko_del_cb(text);
  g_free(text);

  line_number_cb(GTK_TEXT_VIEW(doc->textbox), 0, 0, 0, doc);

  /*Կ򹹿*/
  cm_all_lines = gtk_text_buffer_get_line_count(buffer);
  /* debug */
  /*printf("line_count_delete cm_all_lines : %d\n", cm_all_lines);*/

  return;
}

static void kakko_add_cb(const gchar *buf)
{
  while ((int)*buf != (int)'\0') {
    if ((int)*buf == (int)'{') {
      kakko1_count++;
    }
    else if ((int)*buf == (int)'}') {
      kakko1_count--;
    }
    else if ((int)*buf == (int)'(') {
      kakko2_count++;
    }
    else if ((int)*buf == (int)')') {
      kakko2_count--;
    }
    buf++;
  }
  /*printf("{%d} (%d)\n", kakko1_count, kakko2_count);*/
  return;
}

static void kakko_del_cb(const gchar *buf)
{
  while ((int)*buf != (int)'\0') {
    if ((int)*buf == (int)'{') {
      kakko1_count--;
    }
    else if ((int)*buf == (int)'}') {
      kakko1_count++;
    }
    else if ((int)*buf == (int)'(') {
      kakko2_count--;
    }
    else if ((int)*buf == (int)')') {
      kakko2_count++;
    }
    buf++;
  }
  /*printf("{%d} (%d)\n", kakko1_count, kakko2_count);*/
  return;
}

/******************************************
   ֹ湹ΰ٤Υǡؿ
 ******************************************/
/* char_countgtk_text_get_lengthͤϤ */
void line_number_init_cb(gpointer cur_doc)
{
  struct text_struct *doc;
  GtkTextBuffer *buffer;

  doc = (struct text_struct *)cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  /*Կ򹹿*/
  cm_all_lines = gtk_text_buffer_get_line_count(buffer);

  return;
}

/****************************************
   åȰ֤ιֹ򹹿ؿ
 ****************************************/
void
line_number_cb(GtkTextView *text_view,
               GtkMovementStep step,
               gint count,
               gboolean extend_selection,
               gpointer cur_doc)
{
  GtkTextBuffer *buffer;
  GtkTextIter ins_iter;

  /* 硼ȥåȥǽλ褦Ȥȥ顼å */
  /* ФΤǡ򤹤ե饰å         */
  if (cm_end_flag == 1) {
    return;
  }

  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(text_view));
  gtk_text_buffer_get_iter_at_mark(buffer,
                                   &ins_iter,
                                   gtk_text_buffer_get_mark(buffer, "insert"));
  /* Է */
  line = gtk_text_iter_get_line(&ins_iter);
  column = gtk_text_iter_get_line_offset(&ins_iter);

  mlwrite(ML_E_ONLY,
          ML_DELAYED,
          MODE_LINE_DEFAULT_MSG,
          kakko1_count,
          kakko2_count,
          line + 1,
          column);

  return;
}

gint
line_number_btn_cb(GtkWidget *widget,
                   GdkEvent *event,
                   gpointer cur_doc)
{
  struct text_struct *doc;

  doc = (struct text_struct *)cur_doc;
  line_number_cb(GTK_TEXT_VIEW(doc->textbox), 0, 0, 0, doc);
  return(FALSE);
}
