/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * Ӳΰ٤δؿ
 */

/*
 * Cmemo : Text Editor
 * search.c - source file for searching strings
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "cme_def.h"
#include "cmemo.h"
#include "linenum.h"
#include "cme_misc.h"
#include "bm_search.h"


#define SEARCH_UP 0
#define SEARCH_DN 1

int cm_ignore_case;


/************
   岼
 ************/
/* 0:FALSE 1:TRUE  */
int search_up_dn(unsigned char *s_text, unsigned char *s_word,
                 long *count_from_start, long *num_of_char,
                 int up_dn_flag, int matchcase)
{
  int hit_pos;
  unsigned char *search_p;

  if (up_dn_flag == SEARCH_UP) {
    hit_pos = bm_re_search(s_text,
                           strlen(s_text),
                           s_word,
                           strlen(s_word),
                           matchcase);
  }
  else { /* SEARCH_DN */
    hit_pos = bm_search(s_text,
                        strlen(s_text),
                        s_word,
                        strlen(s_word),
                        matchcase);
  }

  /* ȯñؤΥݥ󥿤򥻥å */
  if (hit_pos == -1) {
    search_p = NULL;
  }
  else {
    search_p = s_text + hit_pos;
  }

  /* ȯ褿ɤˤäƽ򿶤ʬ */
  if (search_p == NULL) {
    return(0);
  }
  else {
    /*ȯ֤ޤǤʸ򥫥Ȥ*/
    *count_from_start = get_char_count(s_text, search_p - s_text);

    /*ñʸ򥫥Ȥ*/
    *num_of_char = get_char_count(s_word, strlen(s_word));

    /*ñȯ*/
    return(1);
  }
  return(0);
}

/*****************************************************************
   ʸʸΰ㤤̵뤹뤫ɤΥե饰ONޤOFF
 *****************************************************************/
int case_on_off(GtkWidget *widget, gpointer data)
{
  if (cm_ignore_case == 0) {
    cm_ignore_case = 1;
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, IGNORE_CASE);
  }
  else {
    cm_ignore_case = 0;
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, DONT_IGNORE_CASE);
  }
  return(0);
}

/**************
   
 **************/
void up_search(GtkWidget *widget, gpointer cur_doc)
{
  int res;
  long count_s;
  long count_c;
  unsigned char *s_text;
  unsigned char *s_word;
  gint f_line;
  gint f_column;
  struct text_struct *doc;
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;
  GtkTextIter mark_iter;


  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  count_s = 0;
  count_c = 0;
  gtk_widget_grab_focus(doc->textbox);

  s_word = gtk_editable_get_chars(GTK_EDITABLE(cm_search.entry), 0, -1);
  if ((s_word == NULL) || ((int)*s_word == (int)'\0')) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, "Input Word to Search!!");
    if (s_word) {
      g_free(s_word);
    }
    return;
  }

  gtk_text_buffer_get_start_iter(buffer, &start_iter);
  gtk_text_buffer_get_iter_at_mark(buffer,
                                   &end_iter,
                                   gtk_text_buffer_get_mark(buffer, "insert"));
  s_text = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);
  if (s_text == NULL) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, "fail to malloc...");
    return;
  }
  res = search_up_dn(s_text, s_word, &count_s, &count_c, SEARCH_UP, cm_ignore_case);

  /*debug*/
  /*printf("result is %d\n", res);
  printf("Ƭ %d ʸ\n", count_s);
  printf("ʸ %d ʸ\n", count_c);*/

  /* ҥåȤ */
  if (res == 1) {
    /* ȯʸȿž */
    memcpy(&mark_iter, &start_iter, sizeof(GtkTextIter));
    gtk_text_iter_forward_chars(&start_iter, count_s);
    gtk_text_iter_forward_chars(&mark_iter, count_s + count_c);
    gtk_text_buffer_place_cursor(buffer, &start_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "selection_bound", &mark_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "insert", &start_iter);

    /* Է */
    f_line = gtk_text_iter_get_line(&mark_iter);
    f_column = gtk_text_iter_get_line_offset(&mark_iter);

    /*  */
    scrollbar_update(doc, f_line, &start_iter);

    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            "matched in line %d column %d",
            f_line + 1, f_column);
    set_cur_line_number(f_line);
  }
  else {
    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            "not matched (current line %d)",
            get_cur_line_number() + 1);
  }

  g_free(s_word);
  g_free(s_text);
  return;
}

/**************
   
 **************/
void dn_search(GtkWidget *widget, gpointer cur_doc)
{
  int res;
  long count_s;
  long count_c;
  unsigned char *s_text;
  unsigned char *s_word;
  gint f_line;
  gint f_column;
  struct text_struct *doc;
  GtkTextBuffer *buffer;
  GtkTextIter start_iter;
  GtkTextIter end_iter;
  GtkTextIter mark_iter;


  doc = cur_doc;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));
  count_s = 0;
  count_c = 0;
  gtk_widget_grab_focus(doc->textbox);

  s_word = gtk_editable_get_chars(GTK_EDITABLE(cm_search.entry), 0, -1);
  if ((s_word == NULL) || ((int)*s_word == (int)'\0')) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, "Input Word to Search!!");
    if (s_word) {
      g_free(s_word);
    }
    return;
  }

  gtk_text_buffer_get_iter_at_mark(buffer,
                                   &start_iter,
                                   gtk_text_buffer_get_mark(buffer, "insert"));
  gtk_text_buffer_get_end_iter(buffer, &end_iter);
  s_text = gtk_text_buffer_get_text(buffer, &start_iter, &end_iter, TRUE);
  if (s_text == NULL) {
    mlwrite(ML_E_ONLY, ML_IMMEDIATELY, "fail to malloc...");
    return;
  }
  res = search_up_dn(s_text, s_word, &count_s, &count_c, SEARCH_DN, cm_ignore_case);

  /*debug*/
  /*printf("result is %d\n", res);
  printf("Ƭ %d ʸ\n", count_s);
  printf("ʸ %d ʸ\n", count_c);*/

  /* ҥåȤ */
  if (res == 1) {
    /* ȯʸȿž */
    memcpy(&mark_iter, &start_iter, sizeof(GtkTextIter));
    gtk_text_iter_forward_chars(&mark_iter, count_s);
    gtk_text_iter_forward_chars(&start_iter, count_s + count_c);
    gtk_text_buffer_place_cursor(buffer, &start_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "selection_bound", &mark_iter);
    gtk_text_buffer_move_mark_by_name(buffer, "insert", &start_iter);

    /* Է */
    f_line = gtk_text_iter_get_line(&mark_iter);
    f_column = gtk_text_iter_get_line_offset(&mark_iter);

    /*  */
    scrollbar_update(doc, f_line, &start_iter);

    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            "matched in line %d column %d",
            f_line + 1,
            f_column);
    set_cur_line_number(f_line);
  }
  else {
    mlwrite(ML_E_ONLY,
            ML_IMMEDIATELY,
            "not matched (current line %d)",
            get_cur_line_number() + 1);
  }

  g_free(s_word);
  g_free(s_text);
  return;
}
