/*
 * GTK+(2.x.x)ѤPC-UNIXѥĢΥ
 *
 *  ShiftJISEUC-JPѴơ֥ǡ
 *  ׻ˤäѴǤʤʬΥǡ
 */

/*
 * Cmemo : Text Editor
 * sjis2euc.h - sjis-euc convert table data header file
 *
 * Copyright (C) 2005 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


typedef struct sjis2euc_table {
	unsigned short sjis;
	unsigned short euc;
}	sjis2euc_table_t;

/* ShiftJISEUC-JPѴǡ           */
/* إå˽ҤΤϤ */
/* staticѿʤΤɤȤ롣(20050905) */
static sjis2euc_table_t sjis_to_euc_table[] = {
	{0xFA40, 0xFCF1},
	{0xFA41, 0xFCF2},
	{0xFA42, 0xFCF3},
	{0xFA43, 0xFCF4},
	{0xFA44, 0xFCF5},
	{0xFA45, 0xFCF6},
	{0xFA46, 0xFCF7},
	{0xFA47, 0xFCF8},
	{0xFA48, 0xFCF9},
	{0xFA49, 0xFCFA},
	{0xFA4A, 0xADB5},
	{0xFA4B, 0xADB6},
	{0xFA4C, 0xADB7},
	{0xFA4D, 0xADB8},
	{0xFA4E, 0xADB9},
	{0xFA4F, 0xADBA},
	{0xFA50, 0xADBB},
	{0xFA51, 0xADBC},
	{0xFA52, 0xADBD},
	{0xFA53, 0xADBE},
	{0xFA54, 0xA2CC},
	{0xFA55, 0xFCFC},
	{0xFA56, 0xFCFD},
	{0xFA57, 0xFCFE},
	{0xFA58, 0xADEA},
	{0xFA59, 0xADE2},
	{0xFA5A, 0xADE4},
	{0xFA5B, 0xA2E8},
	{0xFA5C, 0xF9A1},
	{0xFA5D, 0xF9A2},
	{0xFA5E, 0xF9A3},
	{0xFA5F, 0xF9A4},
	{0xFA60, 0xF9A5},
	{0xFA61, 0xF9A6},
	{0xFA62, 0xF9A7},
	{0xFA63, 0xF9A8},
	{0xFA64, 0xF9A9},
	{0xFA65, 0xF9AA},
	{0xFA66, 0xF9AB},
	{0xFA67, 0xF9AC},
	{0xFA68, 0xF9AD},
	{0xFA69, 0xF9AE},
	{0xFA6A, 0xF9AF},
	{0xFA6B, 0xF9B0},
	{0xFA6C, 0xF9B1},
	{0xFA6D, 0xF9B2},
	{0xFA6E, 0xF9B3},
	{0xFA6F, 0xF9B4},
	{0xFA70, 0xF9B5},
	{0xFA71, 0xF9B6},
	{0xFA72, 0xF9B7},
	{0xFA73, 0xF9B8},
	{0xFA74, 0xF9B9},
	{0xFA75, 0xF9BA},
	{0xFA76, 0xF9BB},
	{0xFA77, 0xF9BC},
	{0xFA78, 0xF9BD},
	{0xFA79, 0xF9BE},
	{0xFA7A, 0xF9BF},
	{0xFA7B, 0xF9C0},
	{0xFA7C, 0xF9C1},
	{0xFA7D, 0xF9C2},
	{0xFA7E, 0xF9C3},
	{0xFA80, 0xF9C4},
	{0xFA81, 0xF9C5},
	{0xFA82, 0xF9C6},
	{0xFA83, 0xF9C7},
	{0xFA84, 0xF9C8},
	{0xFA85, 0xF9C9},
	{0xFA86, 0xF9CA},
	{0xFA87, 0xF9CB},
	{0xFA88, 0xF9CC},
	{0xFA89, 0xF9CD},
	{0xFA8A, 0xF9CE},
	{0xFA8B, 0xF9CF},
	{0xFA8C, 0xF9D0},
	{0xFA8D, 0xF9D1},
	{0xFA8E, 0xF9D2},
	{0xFA8F, 0xF9D3},
	{0xFA90, 0xF9D4},
	{0xFA91, 0xF9D5},
	{0xFA92, 0xF9D6},
	{0xFA93, 0xF9D7},
	{0xFA94, 0xF9D8},
	{0xFA95, 0xF9D9},
	{0xFA96, 0xF9DA},
	{0xFA97, 0xF9DB},
	{0xFA98, 0xF9DC},
	{0xFA99, 0xF9DD},
	{0xFA9A, 0xF9DE},
	{0xFA9B, 0xF9DF},
	{0xFA9C, 0xF9E0},
	{0xFA9D, 0xF9E1},
	{0xFA9E, 0xF9E2},
	{0xFA9F, 0xF9E3},
	{0xFAA0, 0xF9E4},
	{0xFAA1, 0xF9E5},
	{0xFAA2, 0xF9E6},
	{0xFAA3, 0xF9E7},
	{0xFAA4, 0xF9E8},
	{0xFAA5, 0xF9E9},
	{0xFAA6, 0xF9EA},
	{0xFAA7, 0xF9EB},
	{0xFAA8, 0xF9EC},
	{0xFAA9, 0xF9ED},
	{0xFAAA, 0xF9EE},
	{0xFAAB, 0xF9EF},
	{0xFAAC, 0xF9F0},
	{0xFAAD, 0xF9F1},
	{0xFAAE, 0xF9F2},
	{0xFAAF, 0xF9F3},
	{0xFAB0, 0xF9F4},
	{0xFAB1, 0xF9F5},
	{0xFAB2, 0xF9F6},
	{0xFAB3, 0xF9F7},
	{0xFAB4, 0xF9F8},
	{0xFAB5, 0xF9F9},
	{0xFAB6, 0xF9FA},
	{0xFAB7, 0xF9FB},
	{0xFAB8, 0xF9FC},
	{0xFAB9, 0xF9FD},
	{0xFABA, 0xF9FE},
	{0xFABB, 0xFAA1},
	{0xFABC, 0xFAA2},
	{0xFABD, 0xFAA3},
	{0xFABE, 0xFAA4},
	{0xFABF, 0xFAA5},
	{0xFAC0, 0xFAA6},
	{0xFAC1, 0xFAA7},
	{0xFAC2, 0xFAA8},
	{0xFAC3, 0xFAA9},
	{0xFAC4, 0xFAAA},
	{0xFAC5, 0xFAAB},
	{0xFAC6, 0xFAAC},
	{0xFAC7, 0xFAAD},
	{0xFAC8, 0xFAAE},
	{0xFAC9, 0xFAAF},
	{0xFACA, 0xFAB0},
	{0xFACB, 0xFAB1},
	{0xFACC, 0xFAB2},
	{0xFACD, 0xFAB3},
	{0xFACE, 0xFAB4},
	{0xFACF, 0xFAB5},
	{0xFAD0, 0xFAB6},
	{0xFAD1, 0xFAB7},
	{0xFAD2, 0xFAB8},
	{0xFAD3, 0xFAB9},
	{0xFAD4, 0xFABA},
	{0xFAD5, 0xFABB},
	{0xFAD6, 0xFABC},
	{0xFAD7, 0xFABD},
	{0xFAD8, 0xFABE},
	{0xFAD9, 0xFABF},
	{0xFADA, 0xFAC0},
	{0xFADB, 0xFAC1},
	{0xFADC, 0xFAC2},
	{0xFADD, 0xFAC3},
	{0xFADE, 0xFAC4},
	{0xFADF, 0xFAC5},
	{0xFAE0, 0xFAC6},
	{0xFAE1, 0xFAC7},
	{0xFAE2, 0xFAC8},
	{0xFAE3, 0xFAC9},
	{0xFAE4, 0xFACA},
	{0xFAE5, 0xFACB},
	{0xFAE6, 0xFACC},
	{0xFAE7, 0xFACD},
	{0xFAE8, 0xFACE},
	{0xFAE9, 0xFACF},
	{0xFAEA, 0xFAD0},
	{0xFAEB, 0xFAD1},
	{0xFAEC, 0xFAD2},
	{0xFAED, 0xFAD3},
	{0xFAEE, 0xFAD4},
	{0xFAEF, 0xFAD5},
	{0xFAF0, 0xFAD6},
	{0xFAF1, 0xFAD7},
	{0xFAF2, 0xFAD8},
	{0xFAF3, 0xFAD9},
	{0xFAF4, 0xFADA},
	{0xFAF5, 0xFADB},
	{0xFAF6, 0xFADC},
	{0xFAF7, 0xFADD},
	{0xFAF8, 0xFADE},
	{0xFAF9, 0xFADF},
	{0xFAFA, 0xFAE0},
	{0xFAFB, 0xFAE1},
	{0xFAFC, 0xFAE2},
	{0xFB40, 0xFAE3},
	{0xFB41, 0xFAE4},
	{0xFB42, 0xFAE5},
	{0xFB43, 0xFAE6},
	{0xFB44, 0xFAE7},
	{0xFB45, 0xFAE8},
	{0xFB46, 0xFAE9},
	{0xFB47, 0xFAEA},
	{0xFB48, 0xFAEB},
	{0xFB49, 0xFAEC},
	{0xFB4A, 0xFAED},
	{0xFB4B, 0xFAEE},
	{0xFB4C, 0xFAEF},
	{0xFB4D, 0xFAF0},
	{0xFB4E, 0xFAF1},
	{0xFB4F, 0xFAF2},
	{0xFB50, 0xFAF3},
	{0xFB51, 0xFAF4},
	{0xFB52, 0xFAF5},
	{0xFB53, 0xFAF6},
	{0xFB54, 0xFAF7},
	{0xFB55, 0xFAF8},
	{0xFB56, 0xFAF9},
	{0xFB57, 0xFAFA},
	{0xFB58, 0xFAFB},
	{0xFB59, 0xFAFC},
	{0xFB5A, 0xFAFD},
	{0xFB5B, 0xFAFE},
	{0xFB5C, 0xFBA1},
	{0xFB5D, 0xFBA2},
	{0xFB5E, 0xFBA3},
	{0xFB5F, 0xFBA4},
	{0xFB60, 0xFBA5},
	{0xFB61, 0xFBA6},
	{0xFB62, 0xFBA7},
	{0xFB63, 0xFBA8},
	{0xFB64, 0xFBA9},
	{0xFB65, 0xFBAA},
	{0xFB66, 0xFBAB},
	{0xFB67, 0xFBAC},
	{0xFB68, 0xFBAD},
	{0xFB69, 0xFBAE},
	{0xFB6A, 0xFBAF},
	{0xFB6B, 0xFBB0},
	{0xFB6C, 0xFBB1},
	{0xFB6D, 0xFBB2},
	{0xFB6E, 0xFBB3},
	{0xFB6F, 0xFBB4},
	{0xFB70, 0xFBB5},
	{0xFB71, 0xFBB6},
	{0xFB72, 0xFBB7},
	{0xFB73, 0xFBB8},
	{0xFB74, 0xFBB9},
	{0xFB75, 0xFBBA},
	{0xFB76, 0xFBBB},
	{0xFB77, 0xFBBC},
	{0xFB78, 0xFBBD},
	{0xFB79, 0xFBBE},
	{0xFB7A, 0xFBBF},
	{0xFB7B, 0xFBC0},
	{0xFB7C, 0xFBC1},
	{0xFB7D, 0xFBC2},
	{0xFB7E, 0xFBC3},
	{0xFB80, 0xFBC4},
	{0xFB81, 0xFBC5},
	{0xFB82, 0xFBC6},
	{0xFB83, 0xFBC7},
	{0xFB84, 0xFBC8},
	{0xFB85, 0xFBC9},
	{0xFB86, 0xFBCA},
	{0xFB87, 0xFBCB},
	{0xFB88, 0xFBCC},
	{0xFB89, 0xFBCD},
	{0xFB8A, 0xFBCE},
	{0xFB8B, 0xFBCF},
	{0xFB8C, 0xFBD0},
	{0xFB8D, 0xFBD1},
	{0xFB8E, 0xFBD2},
	{0xFB8F, 0xFBD3},
	{0xFB90, 0xFBD4},
	{0xFB91, 0xFBD5},
	{0xFB92, 0xFBD6},
	{0xFB93, 0xFBD7},
	{0xFB94, 0xFBD8},
	{0xFB95, 0xFBD9},
	{0xFB96, 0xFBDA},
	{0xFB97, 0xFBDB},
	{0xFB98, 0xFBDC},
	{0xFB99, 0xFBDD},
	{0xFB9A, 0xFBDE},
	{0xFB9B, 0xFBDF},
	{0xFB9C, 0xFBE0},
	{0xFB9D, 0xFBE1},
	{0xFB9E, 0xFBE2},
	{0xFB9F, 0xFBE3},
	{0xFBA0, 0xFBE4},
	{0xFBA1, 0xFBE5},
	{0xFBA2, 0xFBE6},
	{0xFBA3, 0xFBE7},
	{0xFBA4, 0xFBE8},
	{0xFBA5, 0xFBE9},
	{0xFBA6, 0xFBEA},
	{0xFBA7, 0xFBEB},
	{0xFBA8, 0xFBEC},
	{0xFBA9, 0xFBED},
	{0xFBAA, 0xFBEE},
	{0xFBAB, 0xFBEF},
	{0xFBAC, 0xFBF0},
	{0xFBAD, 0xFBF1},
	{0xFBAE, 0xFBF2},
	{0xFBAF, 0xFBF3},
	{0xFBB0, 0xFBF4},
	{0xFBB1, 0xFBF5},
	{0xFBB2, 0xFBF6},
	{0xFBB3, 0xFBF7},
	{0xFBB4, 0xFBF8},
	{0xFBB5, 0xFBF9},
	{0xFBB6, 0xFBFA},
	{0xFBB7, 0xFBFB},
	{0xFBB8, 0xFBFC},
	{0xFBB9, 0xFBFD},
	{0xFBBA, 0xFBFE},
	{0xFBBB, 0xFCA1},
	{0xFBBC, 0xFCA2},
	{0xFBBD, 0xFCA3},
	{0xFBBE, 0xFCA4},
	{0xFBBF, 0xFCA5},
	{0xFBC0, 0xFCA6},
	{0xFBC1, 0xFCA7},
	{0xFBC2, 0xFCA8},
	{0xFBC3, 0xFCA9},
	{0xFBC4, 0xFCAA},
	{0xFBC5, 0xFCAB},
	{0xFBC6, 0xFCAC},
	{0xFBC7, 0xFCAD},
	{0xFBC8, 0xFCAE},
	{0xFBC9, 0xFCAF},
	{0xFBCA, 0xFCB0},
	{0xFBCB, 0xFCB1},
	{0xFBCC, 0xFCB2},
	{0xFBCD, 0xFCB3},
	{0xFBCE, 0xFCB4},
	{0xFBCF, 0xFCB5},
	{0xFBD0, 0xFCB6},
	{0xFBD1, 0xFCB7},
	{0xFBD2, 0xFCB8},
	{0xFBD3, 0xFCB9},
	{0xFBD4, 0xFCBA},
	{0xFBD5, 0xFCBB},
	{0xFBD6, 0xFCBC},
	{0xFBD7, 0xFCBD},
	{0xFBD8, 0xFCBE},
	{0xFBD9, 0xFCBF},
	{0xFBDA, 0xFCC0},
	{0xFBDB, 0xFCC1},
	{0xFBDC, 0xFCC2},
	{0xFBDD, 0xFCC3},
	{0xFBDE, 0xFCC4},
	{0xFBDF, 0xFCC5},
	{0xFBE0, 0xFCC6},
	{0xFBE1, 0xFCC7},
	{0xFBE2, 0xFCC8},
	{0xFBE3, 0xFCC9},
	{0xFBE4, 0xFCCA},
	{0xFBE5, 0xFCCB},
	{0xFBE6, 0xFCCC},
	{0xFBE7, 0xFCCD},
	{0xFBE8, 0xFCCE},
	{0xFBE9, 0xFCCF},
	{0xFBEA, 0xFCD0},
	{0xFBEB, 0xFCD1},
	{0xFBEC, 0xFCD2},
	{0xFBED, 0xFCD3},
	{0xFBEE, 0xFCD4},
	{0xFBEF, 0xFCD5},
	{0xFBF0, 0xFCD6},
	{0xFBF1, 0xFCD7},
	{0xFBF2, 0xFCD8},
	{0xFBF3, 0xFCD9},
	{0xFBF4, 0xFCDA},
	{0xFBF5, 0xFCDB},
	{0xFBF6, 0xFCDC},
	{0xFBF7, 0xFCDD},
	{0xFBF8, 0xFCDE},
	{0xFBF9, 0xFCDF},
	{0xFBFA, 0xFCE0},
	{0xFBFB, 0xFCE1},
	{0xFBFC, 0xFCE2},
	{0xFC40, 0xFCE3},
	{0xFC41, 0xFCE4},
	{0xFC42, 0xFCE5},
	{0xFC43, 0xFCE6},
	{0xFC44, 0xFCE7},
	{0xFC45, 0xFCE8},
	{0xFC46, 0xFCE9},
	{0xFC47, 0xFCEA},
	{0xFC48, 0xFCEB},
	{0xFC49, 0xFCEC},
	{0xFC4A, 0xFCED},
	{0xFC4B, 0xFCEE},
};
static int sjis_to_euc_table_size = sizeof(sjis_to_euc_table)/sizeof(sjis_to_euc_table[0]);
