/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * ʣ󥢥ɥɥ¸뤿δؿ
 *
 * ----ѹ----------------------------------------------
 * ܸƥȥեԽΥɥɥΥݡ
 * СΥåץǡ(ΥåץǡȤȤ)
 * ɥɥ¹Ի餫ˤ    
 * --------------------------------------------------------
 * undo_all_cb()redo_all_cb()CmemoǤ̤
 */

/**********************************************************************
 copied from bluefish-0.3.2 code, modified for use in Cmemo  
 modifications (C) 2000, 2001, 2002 Seiji Tamura stamura@mc.neweb.ne.jp
 **********************************************************************/

/* 
 * Copyright (C) 1998 Andy C. Kahn <kahn@zk3.dec.com>
 * http://ack.netpedia.net/gnp/
 *
 * copied from gnotepad code, modified for use in Bluefish
 * modifications (C) 1999 Olivier Sessink olivier@lx.student.wau.nl
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <string.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "linenum.h"
#include "undo.h"
#include "ini_file.h"
#include "cme_misc.h"


typedef struct {
  char *text;    /* text to be inserted or deleted */
  int start;     /* starts at this position */
  int end;       /* ends at this position */
  gint changed;  /* doc changed status at this undo node */
  undo_op_t op;  /* action to execute */
  gfloat value;  /* Сΰ */
} undo_t;

/* local declarations */
static void undo_redo_common (gboolean which);


/*
 * PUBLIC: doc_insert_text_cb, copied from doc.c in the gnotepad code
 *
 * callback for text widget for text insertion from keyboard typing.  note that
 * this routine and the next one (doc_delete_text_cb()), gets invoked for EVERY
 * key typed by the user.
 */
void
doc_insert_text_cb(GtkTextBuffer *buffer,
                   GtkTextIter *iter,
                   const gchar *text,
                   gint len,
                   gpointer data)
{
  char *buf;
  int start;
  int end;
  gfloat vs_value;
  struct text_struct *doc;

  doc = (struct text_struct *)data;
  vs_value = GTK_TEXT_VIEW(doc->textbox)->vadjustment->value;
  buf = g_new0(char, len + 1);
  strncpy (buf, text, len);
  start = gtk_text_iter_get_offset(iter);
  end = start + len;
  undo_list_add(doc, buf, start, end, UndoInsert, vs_value);
  doc->modified = 1;

  /* debug */
  /*printf("-------------------------\n");
  printf("doc_insert_text_cb\n");
  printf("text %s\n", text);
  printf("len %d\n", len);
  printf("offset %d\n", gtk_text_iter_get_offset(iter));*/
  return;
} /* doc_insert_text_cb */

/*
 * PUBLIC: doc_delete_text_cb, copied from doc.c in the gnotepad code
 *
 * callback for text widget for text deletion from keyboard typing
 */
void
doc_delete_text_cb(GtkTextBuffer *buffer,
                   GtkTextIter *start,
                   GtkTextIter *end,
                   gpointer data)
{
  char *text;
  int start_pos;
  int end_pos;
  gfloat vs_value;
  struct text_struct *doc;

  doc = (struct text_struct *)data;
  vs_value = GTK_TEXT_VIEW(doc->textbox)->vadjustment->value;
  text = gtk_text_buffer_get_text(buffer, start, end, TRUE);
  start_pos = gtk_text_iter_get_offset(start);
  end_pos = gtk_text_iter_get_offset(end);
  undo_list_add(doc, text, start_pos, end_pos, UndoDelete, vs_value);
  doc->modified = 1;

  /* debug */
  /*printf("-------------------------\n");
  printf("doc_delete_text_cb\n");
  printf("text %s\n", text);
  printf("start_pos %d\n", start_pos);
  printf("end_pos %d\n", end_pos);
  printf("start line %d\n", gtk_text_iter_get_line(start));
  printf("start line %d\n", gtk_text_iter_get_line(end));*/
  return;
} /* doc_delete_text_cb */

/*
 * adds an undo item to the undolist.  if there exists items on the redo list,
 * removes them first.
 */
void
undo_list_add(struct text_struct *doc,
              char *text,
              int start,
              int end,
              undo_op_t op,
              gfloat value)
{
  undo_t *undo;

  undo = g_new(undo_t, 1);
  undo->text = text;
  undo->start = start;
  undo->end = end;
  undo->changed = doc->modified;
  undo->op = op;
  undo->value = value;

  /*
   * if there's anything on the redo list, then we need to wipe out the
   * redo list because we now have new undo items
   */
  if (doc->redolist) {
    doc->redolist = undo_list_delete(doc->redolist);
    doc->redotail = NULL;
  }

  /*
   * add to the undo list.  note that since it's conceivable that the
   * undo list could get extremely long, appending to the list on each
   * key typed by the user would result in awful response time.  so what
   * we do is we keep track of the tail (end) of the list, and always
   * append using the tail.
   */
  if (!doc->undolist) {
    doc->undolist = g_list_append (doc->undolist, undo);
    doc->undotail = doc->undolist;
  }
  else {
    doc->undotail = g_list_append (doc->undotail, undo);
    doc->undotail = g_list_next (doc->undotail);
  }
  return;
} /* undo_list_add */

/*
 * used to remove either the undo list or the redo list.
 */
GList *
undo_list_delete(GList * list)
{
  GList *tmp;
  undo_t *undo;

  while (list) {
    tmp = list;
    list = g_list_remove_link (list, tmp);
    undo = (undo_t *) (tmp->data);
    g_list_free_1 (tmp);
    g_free (undo->text);
    g_free (undo);
  }
  return list;
} /* undo_list_delete */

/*
 * PUBLIC: undo_cb
 *
 * menu callback for the 'undo' command
 */
void
undo_cb (GtkWidget *wgt, gpointer cbdata)
{
  undo_redo_common(0);
}				/* undo_cb */

/*
 * PUBLIC: redo_cb
 *
 * menu callback for the 'redo' command
 */
void
redo_cb(GtkWidget *wgt, gpointer cbdata)
{
  undo_redo_common(1);
} /* redo_cb */

/*
 * which: 0 = undo, 1 = redo
 */
static void
undo_redo_common(gboolean which)
{
  struct text_struct *doc;
  undo_t *undo;
  GList *tmp;
  GList **srchead, **srctail;
  GList **dsthead, **dsttail;
  /*int pt;*/
  GtkTextIter start_iter;
  GtkTextIter end_iter;
  /*unsigned int len;*/
  GtkTextBuffer *buffer;
  gint scroll_line;

  doc = &cm_document;
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(doc->textbox));

  g_assert (which == 0 || which == 1);

  /*
   * we have two lists, the undo list, and the redo list.  here, figure
   * out which one we're using, so that we know which list an item moves
   * from, and which list it moves to.
   */
  if (which == 0) {
    srchead = &doc->undolist;
    srctail = &doc->undotail;
    dsthead = &doc->redolist;
    dsttail = &doc->redotail;
  }
  else {
    srchead = &doc->redolist;
    srctail = &doc->redotail;
    dsthead = &doc->undolist;
    dsttail = &doc->undotail;
  }

  if (!(*srchead) || !GTK_IS_TEXT_VIEW(doc->textbox)) {
    return;
  }

  /*
   * need to stop the signal, because if we add/delete text, it will
   * generate the signal again!
   */
  g_signal_handler_disconnect(G_OBJECT(buffer), doc->ins_txt_id);
  g_signal_handler_disconnect(G_OBJECT(buffer), doc->del_txt_id);

  undo = (undo_t *)(*srctail)->data;
  g_assert(undo->op == UndoInsert || undo->op == UndoDelete);

  /* ֤undo(redo)֤˰ư */
  gtk_text_buffer_get_iter_at_offset(buffer, &start_iter, undo->start);
  gtk_text_buffer_place_cursor(buffer, &start_iter);

  /* Ԥ */
  scroll_line = gtk_text_iter_get_line(&start_iter);
  scrollbar_update(doc, scroll_line, &start_iter);

  if (which == 0) { /* UNDO */
    if (undo->op == UndoInsert) {
      unsigned char *buf;
      int chr_num;    /*ʸ(buf ΥХȿǤϤʤ)*/

      buf = undo->text;
      /*ʸ򥫥Ȥ*/
      chr_num = get_char_count(buf, strlen(buf));
      gtk_text_buffer_get_iter_at_offset(buffer, &end_iter, undo->start + chr_num);
      gtk_text_buffer_delete(buffer, &start_iter, &end_iter);
    }
    else {
      gtk_text_buffer_insert(buffer, &start_iter, undo->text, strlen(undo->text));
    }
  }
  else { /* REDO */
    if (undo->op == UndoInsert) {
      gtk_text_buffer_insert(buffer, &start_iter, undo->text, strlen(undo->text));
    }
    else {
      unsigned char *buf;
      int chr_num;    /*ʸ(buf ΥХȿǤϤʤ)*/

      buf = undo->text;
      /*ʸ򥫥Ȥ*/
      chr_num = get_char_count(buf, strlen(buf));
      gtk_text_buffer_get_iter_at_offset(buffer, &end_iter, undo->start + chr_num);
      gtk_text_buffer_delete(buffer, &start_iter, &end_iter);
    }
  }

  /* remove from src list, and place on dst list */
  tmp = *srctail;
  *srctail = g_list_previous(*srctail);
  *srchead = g_list_remove_link(*srchead, tmp);
  if (!(*dsthead)) {
    *dsthead = g_list_concat(*dsthead, tmp);
    *dsttail = *dsthead;
  }
  else {
    *dsttail = g_list_concat(*dsttail, tmp);
    *dsttail = g_list_next(*dsttail);
  }

  if (!(*srchead)) {
    /* there is nothing to do here */
  }

  /* update the doc info label */
  if ((doc->modified != undo->changed) || which == 1) {
    /* redo is always changed */
    doc->modified = which ? 1 : undo->changed;
  }

  /* now re-establish the signals */
  doc->ins_txt_id = g_signal_connect(G_OBJECT(buffer),
                                     "insert_text",
                                     GTK_SIGNAL_FUNC(doc_insert_text_cb),
                                     doc);
  doc->del_txt_id = g_signal_connect(G_OBJECT(buffer),
                                     "delete_range",
                                     GTK_SIGNAL_FUNC(doc_delete_text_cb),
                                     doc);

  /*undoǤredoǤmodifiedTRUEˤ*/
  doc->modified = TRUE;

  return;
} /* undo_redo_common */

/*
 * PUBLIC: undo_all_cb
 *
 * menu callback for the 'undo all' command
 */
void
undo_all_cb (GtkWidget * wgt, gpointer w)
{
  while (cm_document.undolist)
    undo_redo_common (0);
} /* undo_all_cb */

/*
 * PUBLIC: redo_all_cb
 *
 * menu callback for the 'redo all' command
 */
void
redo_all_cb (GtkWidget * wgt, gpointer w)
{
  while (cm_document.redolist)
    undo_redo_common (1);
} /* redo_all_cb */
