/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * eucutf8ѴΤδؿ
 *
 * ----ѹ--------------------------------------------------
 * Ϥ˥եѤ˥ΥХåեǹԤ褦ѹ
 * ------------------------------------------------------------
 */

/****************************************************************************
 copied from Code Converter for UTF-8 ver.0.1 code, modified for use in Cmemo  
 modifications (C) 2001 Seiji Tamura stamura@mc.neweb.ne.jp
 ****************************************************************************/

/* Code Converter for UTF-8 ver.0.1
 * Copyright (c) 2000 Toshihiro Inoue
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENTSHALL
 * THE AUTHOR BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#include <stdio.h>
#include <string.h>
#include "utf8.h"
#include "jis2ucs.h"

static int b1 = 0;
static int b2 = 0;

void writeUtf8(int c, unsigned char *dst_buf, int *count)
{
  unsigned char c1, c2, c3;

  *count = 0;
  if(c < 0) return;
  if(c < 0x80){
    /*printf("%c", c);*/
    *dst_buf = (unsigned char)c;
    dst_buf++;
    *count = *count + 1;
  }else if(c < 0x800){
    c1 = 0xc0 + (c >> 6);
    c2 = 0x80 + (c & 0x3f);
    /*printf("%c%c", c1, c2);*/
    *dst_buf = (unsigned char)c1;
    dst_buf++;
    *count = *count + 1;
    *dst_buf = (unsigned char)c2;
    dst_buf++;
    *count = *count + 1;
  }else if(c < 0x10000){
    c1 = 0xe0 + (c >> 12);
    c2 = 0x80 + ((c >> 6) & 0x3f);
    c3 = 0x80 + (c & 0x3f);
    /*printf("%c%c%c", c1, c2, c3);*/
    *dst_buf = (unsigned char)c1;
    dst_buf++;
    *count = *count + 1;
    *dst_buf = (unsigned char)c2;
    dst_buf++;
    *count = *count + 1;
    *dst_buf = (unsigned char)c3;
    dst_buf++;
    *count = *count + 1;
  }else{
    /*printf("?");*/
    *dst_buf = (unsigned char)'?';
    dst_buf++;
    *count = *count + 1;
  }
}

int readUtf8(unsigned char *pbuf, int *count)
{
  int c1, c2, c3;

  *count = 0;

  if(b1){
    c1 = b1;
    b1 = b2;
    b2 = 0;
  }else{
    c1 = (int)*pbuf;
    pbuf++;
    *count = *count + 1;
    if(c1 == (int)'\0') return -1;
  }
  if(c1 < 0x80) return c1;
  
  if(b1){
    c2 = b1;
    b1 = 0;
  }else{
    c2 = (int)*pbuf;
    pbuf++;
    *count = *count + 1;
    if(c2 == (int)'\0') return c1;
  }
  if(c2 < 0x80){
    b1 = c2;
    return c1;
  }
  if(c1 < 0xe0) return ((c1 - 0xc0) << 6) + (c2 - 0x80);
  
  c3 = (int)*pbuf;
  pbuf++;
  *count = *count + 1;
  if(c3 == (int)'\0'){
    b1 = c2;
    return c1;
  }
  if(c3 < 0x80){
    b1 = c2;
    b2 = c3;
    return c1;
  }
  return ((c1 - 0xe0) << 12) + ((c2 - 0x80) << 6) + (c3 - 0x80);
}

void lat2utf(unsigned char* file_buf, unsigned char *dst_buf)
{
  int c;
  unsigned char *pos;
  int count;

  pos = file_buf;
  while ((int)*pos != (int)'\0'){
    c = *pos;
    pos++;
    if(c == (int)'\0') break;
    writeUtf8(c, dst_buf, &count);
    dst_buf = dst_buf + count;
  }
}

void euc2utf(unsigned char* file_buf, unsigned char *dst_buf)
{
  int u, c1, c2;
  unsigned char *pos;
  int count;

  pos = file_buf;
  while ((int)*pos != (int)'\0'){
    c1 = *pos;
    pos++;
    if(c1 == (int)'\0') break;
    if(c1 < 0x80){
      /*printf("%c", c1);*/
      *dst_buf = (unsigned char)c1;
      dst_buf++;
      continue;
    }
    c2 = *pos;
    pos++;
    if(c2 == (int)'\0'){
      /*printf("%c", c1);*/
      *dst_buf = (unsigned char)c1;
      dst_buf++;
      break;
    }
    if(c2 < 0x80){
      /*printf("%c", c1);*/
      /*printf("%c", c2);*/
      *dst_buf = (unsigned char)c1;
      dst_buf++;
      *dst_buf = (unsigned char)c2;
      dst_buf++;
      continue;
    }
    if(c1 == 0x8e){
      writeUtf8(c2 + 0xfec0, dst_buf, &count);
      dst_buf = dst_buf + count;
      continue;
    }
    c1 -= 0xa1;
    c2 -= 0xa1;
    if(c1 < 0 || c2 < 0){
      /*printf("?");*/
      *dst_buf = (unsigned char)'?';
      dst_buf++;
      continue;
    }
    u = c1 * 94 + c2;
    if(u >= table_jis2ucs_size){
      /*printf("?");*/
      *dst_buf = (unsigned char)'?';
      dst_buf++;
      continue;
    }
    u = table_jis2ucs[u];
    if(u == 0){
      /*printf("?");*/
      *dst_buf = (unsigned char)'?';
      dst_buf++;
      continue;
    }
    writeUtf8(u, dst_buf, &count);
    dst_buf = dst_buf + count;
  }
}

void utf2lat(unsigned char* file_buf, unsigned char *dst_buf)
{
  int c;
  unsigned char *pos;
  int count;

  pos = file_buf;
  while ((int)*pos != (int)'\0'){
    c = readUtf8(pos, &count);
    pos = pos + count;
    if(c < 0) break;
    if(c < 0x100){
      /*printf("%c", c);*/
      *dst_buf = (unsigned char)c;
      dst_buf++;
    }else{
      /*printf("?");*/
      *dst_buf = (unsigned char)'?';
      dst_buf++;
    }
  }
}

void utf2euc(unsigned char* file_buf, unsigned char *dst_buf)
{
  int c, i;
  unsigned char uj1[65536], uj2[65536], c1, c2;
  unsigned char *pos;
  int count;

  for(i = 0; i < 65536; i++){
    uj1[i] = 0;
    uj2[i] = 0;
  }
  for(i = 0xff61; i < 0xffa0; i++){
    uj2[i] = i - 0xfec0;
  }
  c1 = 0xa1;
  c2 = 0xa1;
  for(i = 0; i < table_jis2ucs_size; i++){
    c = table_jis2ucs[i];
    if(c > 0){
      uj1[c] = c1;
      uj2[c] = c2;
    }
    c2++;
    if(c2 > 0xfe){
      c1++;
      c2 = 0xa1;
    }
  }

  pos = file_buf;
  while ((int)*pos != (int)'\0'){
    c = readUtf8(pos, &count);
    pos = pos + count;
    if(c < 0) break;
    if(c < 0x80){
      /*printf("%c", c);*/
      *dst_buf = (unsigned char)c;
      dst_buf++;
    }else{
      c1 = uj1[c];
      c2 = uj2[c];
      if(c1 == 0){
        if(c2 == 0) {
          /*printf("?");*/
          *dst_buf = (unsigned char)'?';
          dst_buf++;
        }
        else {
          /*printf("%c%c", 0x8e, c2);*/
          *dst_buf = (unsigned char)0x8e;
          dst_buf++;
          *dst_buf = (unsigned char)c2;
          dst_buf++;
        }
      }else{
        /*printf("%c%c", c1, c2);*/
        *dst_buf = (unsigned char)c1;
        dst_buf++;
        *dst_buf = (unsigned char)c2;
        dst_buf++;
      }
    }
  }
}

int utf8_main(char *code, unsigned char *src_buf, unsigned char *dst_buf)
{
  b1 = 0;
  b2 = 0;
  if(strcmp(code, "-eu") == 0) {
    euc2utf(src_buf, dst_buf);
  }
  else if(strcmp(code, "-ul") == 0) {
    utf2lat(src_buf, dst_buf);
  }
  else if(strcmp(code, "-ue") == 0) {
    utf2euc(src_buf, dst_buf);
  }
  else if(strcmp(code, "-lu") == 0) {
    lat2utf(src_buf, dst_buf);
  }
  else {
    /*printf("usage: utf8conv [options] file [file2 ...]\n"
           "\t-lu\tLatin1 -> UTF-8\n"
           "\t-eu\tEUC-JP -> UTF-8\n"
           "\t-ul\tUTF-8  -> Latin1\n"
           "\t-ue\tUTF-8  -> EUC-JP\n");*/
  }
  return 0;
}
