/**********************************************************************
 copied from GTK - The GIMP Toolkit code, modified for use in Cmemo  
 modifications (C) 2002, 2003 Seiji Tamura stamura@mc.neweb.ne.jp
 **********************************************************************/

/* GTK - The GIMP Toolkit
 * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * Modified by the GTK+ Team and others 1997-2000.  See the AUTHORS
 * file for a list of people on the GTK+ Team.  See the ChangeLog
 * files for a list of changes.  These files are distributed with
 * GTK+ at ftp://ftp.gtk.org/pub/gtk/. 
 */

#ifndef __GTK_CM_MENU_BAR_H__
#define __GTK_CM_MENU_BAR_H__


#include <gdk/gdk.h>
#include <gtk/gtkmenushell.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define	GTK_TYPE_CM_MENU_BAR               (gtk_cm_menu_bar_get_type ())
#define GTK_CM_MENU_BAR(obj)               (GTK_CHECK_CAST ((obj), GTK_TYPE_CM_MENU_BAR, GtkCmMenuBar))
#define GTK_CM_MENU_BAR_CLASS(klass)       (GTK_CHECK_CLASS_CAST ((klass), GTK_TYPE_CM_MENU_BAR, GtkCmMenuBarClass))
#define GTK_IS_CM_MENU_BAR(obj)            (GTK_CHECK_TYPE ((obj), GTK_TYPE_CM_MENU_BAR))
#define GTK_IS_CM_MENU_BAR_CLASS(klass)    (GTK_CHECK_CLASS_TYPE ((klass), GTK_TYPE_CM_MENU_BAR))
#define GTK_CM_MENU_BAR_GET_CLASS(obj)     (GTK_CHECK_GET_CLASS ((obj), GTK_TYPE_CM_MENU_BAR, GtkCmMenuBarClass))


typedef struct _GtkCmMenuBar       GtkCmMenuBar;
typedef struct _GtkCmMenuBarClass  GtkCmMenuBarClass;

struct _GtkCmMenuBar
{
  GtkMenuShell menu_shell;
};

struct _GtkCmMenuBarClass
{
  GtkMenuShellClass parent_class;

  /* Padding for future expansion */
  void (*_gtk_reserved1) (void);
  void (*_gtk_reserved2) (void);
  void (*_gtk_reserved3) (void);
  void (*_gtk_reserved4) (void);
};


GtkType    gtk_cm_menu_bar_get_type        (void) G_GNUC_CONST;
GtkWidget* gtk_cm_menu_bar_new             (void);

#define gtk_cm_menu_bar_append(menu,child)     gtk_menu_shell_append  ((GtkMenuShell *)(menu),(child))
#define gtk_cm_menu_bar_prepend(menu,child)    gtk_menu_shell_prepend ((GtkMenuShell *)(menu),(child))
#define gtk_cm_menu_bar_insert(menu,child,pos) gtk_menu_shell_insert ((GtkMenuShell *)(menu),(child),(pos))

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GTK_CM_MENU_BAR_H__ */
